
subroutine statistics()

use vars
use rad, only: qrad
use tracers
use params
use hbuffer
use instrument_diagnostics, only: compute_instr_diags
use terrain
use slm_vars, only: snow_mass, rho_snow, snowt, soilt, t_canop, &
                    lhf_soil, shf_soil, lhf_canop, shf_canop 
use buildings, only: buildings_stat
implicit none	
	
	real mse(nzm)
	real dse(nzm)
	real sse(nzm)
	real tpz(nzm)
	real tlz(nzm)
	real tvz(nzm)
	real qcz(nzm)
	real qiz(nzm)
	real tez(nzm)
	real qvz(nzm)
	real qrz(nzm)
	real qsz(nzm)
	real relhz(nzm)
	real relhiz(nzm)

	real u2z(nzm)
	real v2z(nzm)
	real w2z(nzm)
	real w22(nzm)
	real w3z(nzm)
	real skw(nzm)
	real t2z(nzm)
	real tqz(nzm)
	real q2z(nzm)
	real qc2z(nzm)
	real qi2z(nzm)
	real qs2z(nzm)
	real tkez(nzm)
	real fadv(nz)
	real shear(nz)
	real shearx(nzm)
	real sheary(nzm)
	real presx(nzm)
	real presy(nzm)
	real twgrad(nzm)
	real qwgrad(nzm)
	real swgrad(nzm)
	
	
	real tvwle(nzm)
	real qcwle(nzm)
	real qiwle(nzm)
	real aup(nzm)
	real wcl(nzm)
	real ucl(nzm)
	real vcl(nzm)
	real tcl(nzm)
	real tacl(nzm)
	real tvcl(nzm)
	real qcll(nzm)
	real qccl(nzm)
	real qicl(nzm)
	real qpcl(nzm)
	real twcl(nzm)
	real qwcl(nzm)
	real tvwcl(nzm)
	real qcwcl(nzm)
	real qiwcl(nzm)
	real wacl(nzm)	
	real clds(nzm)
 	real cldd(nzm)
	real hydro(nzm)
	real qsatwz(nzm)

	real tvirt(nx,ny,nzm), tmp3D(nx,ny,nzm)
	
	integer i,j,k,n,ntr
	real qcc,qii,qrr,qss,lstarn,lstarp,coef,coef1
	real factor_xy, factor_n, tmp(4), tmp1(4)
        real buffer(nzm,6),buffer1(nzm,6)
	real prof1(nzm),prof2(nzm),prof3(nzm),prof4(nzm)	
	real cwpmax,cwpt(nx,ny),cwpl(nx,ny),cwpm(nx,ny),cwph(nx,ny)
	logical condition, condition_cl
	real zero(nzm)

	integer topind(nx,ny),z_inv_ind(nx,ny),z_base_ind(nx,ny),z_top_ind(nx,ny),ncloud	
        real zzz,grad_max(nx,ny),grad,www
        real acld, acldl, acldm, acldh

        real(8), external :: water_sum
!========================================================================
! UW ADDITIONS

 real tvcla(nzm)!kzm added Apr. 7,2004 for thetav anomalies
 real wstar3(nzm) !bloss added 11/04/05 

 !bloss: momentum flux statistics for cloud, up/downdraft cores
 real, dimension(nzm) :: uwsbcl, vwsbcl, uwlecl, vwlecl, &
      uadv, vadv, udiff, vdiff
 real :: uwsubgrid, vwsubgrid, uwresolved, vwresolved

 !bloss: new stuff for conditionally-averaged statistics (i.e. cloud, core, etc.)
 integer ncond, jb, kc, kb
 character(LEN=6) :: statname
 real :: tmprhow, tmpmse, tmpqt

 !bloss: conditional u,v anomalies, pressure gradients
 real, dimension(nzm) :: ucla, vcla, dpdxcl, dpdycl, dpdzcl
               
 !bloss: frozen moist static energy
 real, dimension(nzm) :: fmse, fmsecla

 !bloss: mass flux and mass-flux weighted stats in conditional category
real, dimension(nzm) :: rhowcl, rhowmsecl, rhowtlcl, rhowqtcl,  &
     rhowmsecla, rhowtlcla, rhowqtcla, rhouwcl, rhovwcl, rhowwcl, &
     rhowtvcl, rhowtvcla

! END UW ADDITIONS
!========================================================================
real, external :: qsatw,qsati

        call t_startf('statistics')

	factor_xy = 1./float(nx*ny)
	factor_n = 1./float(nsubdomains)
	
!-----------------------------------------------
!	Mean thermodynamics profiles:
!-----------------------------------------------	
		
	do k=1,nzm
	 dse(k)=0.
	 mse(k)=0.
	 sse(k)=0.
	 tpz(k) = 0.
	 tlz(k) = 0.
	 tvz(k) = 0.
	 tez(k) = 0.
	 qvz(k) = 0.
	 qcz(k) = 0.
	 qiz(k) = 0.
	 qrz(k) = 0.
	 qsz(k) = 0.
	 qsatwz(k)=0.
	 relhz(k)=0.
	 relhiz(k)=0.
	 prof1(k)=0.
	 prof2(k)=0.
	 prof3(k)=0.
	 zero(k)=0.
	 do j=1,ny
	  do i=1,nx
           www=wgt(j,k)*terra(i,j,k)
	   qcc=qcl(i,j,k)
	   qii=qci(i,j,k)
	   qrr=qpl(i,j,k)
	   qss=qpi(i,j,k)
           qrz(k)=qrz(k)+qrr*www
           qsz(k)=qsz(k)+qss*www
           qcz(k)=qcz(k)+qcc*www
           qiz(k)=qiz(k)+qii*www
	   prof1(k)=prof1(k)+(qcc+qii)*www
	   prof2(k)=prof2(k)+(qrr+qss)*www
	   prof3(k)=prof3(k)+(qcc+qii+qrr+qss)*www
	   tmp(1)=tabs(i,j,k)*prespot(k)
           tpz(k)=tpz(k)+tmp(1)*www
	   tlz(k)=tlz(k)+tmp(1)*(1.-fac_cond*(qcl(i,j,k)+qci(i,j,k))/tabs(i,j,k))*www
           tvirt(i,j,k)=tmp(1)*(1.+epsv*qv(i,j,k)-(qcl(i,j,k)+qci(i,j,k))-(qpl(i,j,k)+qpi(i,j,k)))*www
	   tvz(k)=tvz(k)+tvirt(i,j,k)*www
           tez(k)=tez(k)+(tabs(i,j,k)+gamaz(k)+fac_cond*qv(i,j,k)-fac_fus*(qii+qss))*www
	   qvz(k) =qvz(k)+qv(i,j,k)*www
     	   dse(k)=dse(k)+(tabs(i,j,k)+gamaz(k))*www
	   mse(k)=mse(k)+(tabs(i,j,k)+gamaz(k)+fac_cond*qv(i,j,k))*www
	   sse(k)=sse(k)+(tabs(i,j,k)+gamaz(k)+fac_cond*qsatw(tabs(i,j,k),pres(k)))*www
	   qsatwz(k) = qsatwz(k)+qsatw(tabs(i,j,k),pres(k))*www
	   relhz(k)=relhz(k)+(qv(i,j,k)/qsatw(tabs(i,j,k),pres(k)))*www
	   relhiz(k)=relhiz(k)+(qv(i,j,k)/qsati(tabs(i,j,k),pres(k)))*www
	  end do
	 end do
	end do	
	
	call hbuf_put('TL',t0,1.)
	call hbuf_put('TABS',tabs0,1.)
	call hbuf_put('U',u0+ug,1.)
	call hbuf_put('V',v0+vg,1.)
	call hbuf_put('QT',q0,1.e3)
	call hbuf_put('TABSOBS',tg0,1.)
	call hbuf_put('QVOBS',qg0,1.e3)
	call hbuf_put('UOBS',ug0,1.)
	call hbuf_put('VOBS',vg0,1.)
        call hbuf_put('WOBS',wsub,1.)
	call hbuf_put('TTEND',ttend,86400.)
	call hbuf_put('QTEND',qtend,86400.*1.e3)

	call hbuf_put('DSE',dse,factor_xy)
	call hbuf_put('MSE',mse,factor_xy)
	call hbuf_put('SSE',sse,factor_xy)
	call hbuf_put('THETA',tpz,factor_xy)
	call hbuf_put('THETAL',tlz,factor_xy)
	call hbuf_put('THETAV',tvz,factor_xy)
	call hbuf_put('THETAE',tez,factor_xy)

	call hbuf_put('PRES',pres,1.)
	call hbuf_put('RHO',rho,1.)
	call hbuf_put('QV',qvz,1.e3*factor_xy)
	call hbuf_put('QCL',qcz,1.e3*factor_xy)
	call hbuf_put('QCI',qiz,1.e3*factor_xy)
	call hbuf_put('QPL',qrz,1.e3*factor_xy)
	call hbuf_put('QPI',qsz,1.e3*factor_xy)
	call hbuf_put('QN',prof1,1.e3*factor_xy)
	call hbuf_put('QP',prof2,1.e3*factor_xy)
	call hbuf_put('QCOND',prof3,1.e3*factor_xy)
	call hbuf_put('QSAT',qsatwz,1.e3*factor_xy)
	call hbuf_put('RELH',relhz,100.*factor_xy)
	call hbuf_put('RELHI',relhiz,100.*factor_xy)

!-------------------------------------------------------------
!	Fluxes:
!-------------------------------------------------------------

	do k=1,nzm
	  tmp(1) = dz/rhow(k)
	  tmp(2) = tmp(1) / dtn
	  uwsb(k) = uwsb(k) * tmp(1)
	  vwsb(k) = vwsb(k) * tmp(1)
	  twsb(k) = twsb(k) * tmp(1) * rhow(k) * cp
	  uwle(k) = uwle(k)*tmp(1) + uwsb(k)
	  vwle(k) = vwle(k)*tmp(1) + vwsb(k)
	  twle(k) = twle(k)*tmp(2)*rhow(k)*cp + twsb(k)
	  if(dotracers) then
           do ntr=1,ntracers
	    trwsb(k,ntr) = trwsb(k,ntr) * tmp(1)*rhow(k)
     	    trwle(k,ntr) = trwle(k,ntr) * tmp(2)*rhow(k) + trwsb(k,ntr)
           end do
          end if
	end do
	uwle(nz) = 0.
	vwle(nz) = 0.
	uwsb(nz) = 0.
	vwsb(nz) = 0.
	call hbuf_put('UW',uwle,factor_xy)
	call hbuf_put('VW',vwle,factor_xy)
	call hbuf_put('UWSB',uwsb,factor_xy)
	call hbuf_put('VWSB',vwsb,factor_xy)
	call hbuf_put('TLFLUX',twle,factor_xy)
	call hbuf_put('TLFLUXS',twsb,factor_xy)
	call hbuf_put('PRECIP',precflux,factor_xy*dz/dts*86400.)
	
	do j=1,ny
	 do i=1,nx
	  precsfc(i,j)=precsfc(i,j)/dtst*86400.
	  precsfcsnow(i,j)=precsfcsnow(i,j)/dtst*86400.
          if(precsfc(i,j).gt.0.1) s_ar = s_ar + wgty(j)
          if(precsfc(i,j)/86400./rhow(1).gt.3.65e-5) s_arthr = s_arthr + wgty(j)
          precmean = precmean+precsfc(i,j)*wgty(j)
          snowmean = snowmean+precsfcsnow(i,j)*wgty(j)
          prec2 = prec2+(precsfc(i,j)**2)*wgty(j)
	 end do
	end do
        precmax = maxval(precsfc(:,:))
        precsfc(:,:) = 0.
        precsfcsnow(:,:) = 0.
        precflux(:) = 0.

	do k=1,nzm
	 tvz(k) = 0.
	 qcz(k) = 0.
	 qiz(k) = 0.
	 qsatwz(k) = 0.
	 prof1(k)=0.
	 prof2(k)=0.
	 do j=1,ny
	  do i=1,nx
            www=wgt(j,k)*terra(i,j,k)
	    tvz(k) = tvz(k) + tvirt(i,j,k)*www
	    qcz(k) = qcz(k) + qcl(i,j,k)*www
	    qiz(k) = qiz(k) + qci(i,j,k)*www
	    qsatwz(k) = qsatwz(k)+qsatw(tabs(i,j,k),pres(k))*www
	  end do
	 end do
	 tvz(k) = tvz(k)*factor_xy
	 qcz(k) = qcz(k)*factor_xy
	 qiz(k) = qiz(k)*factor_xy	 
	 qsatwz(k) = qsatwz(k)*factor_xy
         tmp3D(:,:,k) = qg0(k)
	end do

        wvp = wvp + water_sum(qv)
        cwp = cwp + water_sum(qcl)
        iwp = iwp + water_sum(qci)
        rwp = rwp + water_sum(qpl)
        gwp = gwp + water_sum(qpg)
        swp = swp + water_sum(qpi-qpg)
        wvpobs = wvpobs + water_sum(tmp3D)

	if(dompi) then
	  coef1 = 1./float(nsubdomains)
	  do k=1,nzm
	    buffer(k,1) = tvz(k)
	    buffer(k,2) = qcz(k)
	    buffer(k,3) = qiz(k)
	    buffer(k,4) = qsatwz(k)
	  end do
	  call task_sum_real(buffer,buffer1,nzm*4)
	  do k=1,nzm
	    tvz(k) = buffer1(k,1) * coef1
	    qcz(k) = buffer1(k,2) * coef1
	    qiz(k) = buffer1(k,3) * coef1
	    qsatwz(k) = buffer1(k,4) * coef1
	  end do
	end if ! dompi

	tvwle(1) = 0.
        wstar3(1) = 0. !bloss
	qcwle(1) = 0.
	qiwle(1) = 0.
	do k=2,nzm
	 tvwle(k) = 0.
         wstar3(k) = 0. !bloss
	 qcwle(k) = 0.
	 qiwle(k) = 0.
	 do j=1,ny
	  do i=1,nx
            www=wgt(j,k)*terra(i,j,k)
	    tvwle(k) = tvwle(k) + 0.5*w(i,j,k)* &
		(tvirt(i,j,k-1)-tvz(k-1)+tvirt(i,j,k)-tvz(k))*www
	    qcwle(k) = qcwle(k) + 0.5*w(i,j,k)* &
		(qcl(i,j,k-1)-qcz(k-1)+ qcl(i,j,k)-qcz(k))*www
	    qiwle(k) = qiwle(k) + 0.5*w(i,j,k)* &
                (qci(i,j,k-1)-qiz(k-1)+qci(i,j,k)-qiz(k))*www
	    prof1(k)=prof1(k)+rho(k)*0.5* &
                (w(i,j,k)**2+w(i,j,k+1)**2)*(t(i,j,k)-t0(k))*www
          end do
	 end do
         wstar3(k) = wstar3(k-1) + 2.5*dz*adzw(k)*bet(k)*tvwle(k) !bloss
	 tvwle(k) = tvwle(k)*rhow(k)*cp
	 qcwle(k) = qcwle(k)*rhow(k)*lcond
	 qiwle(k) = qiwle(k)*rhow(k)*lcond
	end do	

	call hbuf_put('TVFLUX',tvwle,factor_xy)
	call hbuf_put('QCFLUX',qcwle,factor_xy)
	call hbuf_put('QIFLUX',qiwle,factor_xy)

        !bloss: UW additions
	call hbuf_put('WSTAR3',wstar3,factor_xy) !bloss

!---------------------------------------------------------
!	Mean turbulence related profiles:
!-----------------------------------------------------------


	do k=1,nzm

	 u2z(k) = 0.
	 v2z(k) = 0.
	 w2z(k) = 0.
	 w22(k) = 0.
	 w3z(k) = 0.
	 aup(k) = 0.
	 t2z(k) = 0.
	 tqz(k) = 0.
	 q2z(k) = 0.
	 qc2z(k) = 0.
	 qi2z(k) = 0.
	 qs2z(k) = 0.
	 do j=1,ny
	  do i=1,nx
            www=wgt(j,k)*terra(i,j,k)
	    u2z(k) = u2z(k)+(u(i,j,k)-u0(k))**2*wgtu(j,k)*terrau(i,j,k)	  
	    v2z(k) = v2z(k)+(v(i,j,k)-v0(k))**2*wgtv(j,k)*terrav(i,j,k)
	    w2z(k) = w2z(k)+0.5*(w(i,j,k+1)**2+w(i,j,k)**2)*wgtw(j,k)*terraw(i,j,k)
	    w22(k) = w22(k)+w(i,j,k)**2*wgtw(j,k)*terraw(i,j,k)
	    w3z(k) = w3z(k)+0.5*(w(i,j,k+1)**3+w(i,j,k)**3)*wgtw(j,k)*terraw(i,j,k)
	    t2z(k) = t2z(k)+(t(i,j,k)-t0(k))**2*wgt(j,k)*terra(i,j,k)	  
	    tqz(k) = tqz(k)+(t(i,j,k)-t0(k))*(qv(i,j,k)+qcl(i,j,k)+qci(i,j,k)-q0(k))*wgt(j,k)*terra(i,j,k)
	    q2z(k) = q2z(k)+(qv(i,j,k)+qcl(i,j,k)+qci(i,j,k)-q0(k))**2*wgt(j,k)*terra(i,j,k)
	    if(w(i,j,k)+w(i,j,k+1).gt.0) aup(k) = aup(k) + wgt(j,k)*terra(i,j,k)
	  end do
	 end do
	 skw(k) = w3z(k)/(w2z(k)*factor_xy+1.e-5)**1.5
	 tkez(k)= 0.5*(u2z(k)+v2z(k)*YES3D+w2z(k))
	 tvwle(k) = tvwle(k) * bet(k) /(rho(k)*cp)
	 do j=1,ny
	  do i=1,nx
	    qc2z(k) = qc2z(k)+(qcl(i,j,k)-qcz(k))**2*wgt(j,k)*terra(i,j,k)
	    qi2z(k) = qi2z(k)+(qci(i,j,k)-qiz(k))**2*wgt(j,k)*terra(i,j,k)
	    qs2z(k) = qs2z(k)+(qsatw(tabs(i,j,k),pres(k))-qsatwz(k))**2*wgt(j,k)*terra(i,j,k)
	  end do
	 end do
	 
	end do

	call hbuf_put('U2',u2z,factor_xy)
	call hbuf_put('V2',v2z,factor_xy)
	call hbuf_put('W2',w2z,factor_xy)
	call hbuf_put('W3',w3z,factor_xy)
	call hbuf_put('WSKEW',skw,factor_xy)
	call hbuf_put('AUP',aup,factor_xy)

	call hbuf_put('TL2',t2z,factor_xy)
	call hbuf_put('TQ',tqz,factor_xy)
	call hbuf_put('QT2',q2z,1.e6*factor_xy)
	call hbuf_put('QC2',qc2z,1.e6*factor_xy)
	call hbuf_put('QI2',qi2z,1.e6*factor_xy)
	call hbuf_put('QS2',qs2z,1.e6*factor_xy)
	
	call hbuf_put('TKE',tkez,factor_xy)
!-----------------------------------------------------------------
!  TKE balance:

        shear(1)=0.
        shear(nz)=0.
        do k=2,nzm
          shear(k)=-( (uwle(k)-uwsb(k))*(u0(k)-u0(k-1)) &
            +(vwle(k)-vwsb(k))*(v0(k)-v0(k-1))*YES3D )*factor_xy /(dz*adzw(k))
        end do
        do k=1,nzm
          shear(k)=0.5*(shear(k)+shear(k+1))
          tkeleadv(k)=tkeleadv(k)-shear(k)
          tkelediff(k)=tkelediff(k)-tkelediss(k)
        end do

        call hbuf_put('ADVTR',tkeleadv,1.)
        call hbuf_put('PRESSTR',tkelepress,1.)
        call hbuf_put('BUOYA',tkelebuoy,1.)
        call hbuf_put('SHEAR',shear,1.)
        call hbuf_put('DISSIP',tkelediss,1.)
        call hbuf_put('DIFTR',tkelediff,1.)
	
	fadv(1)=0.
	fadv(nz)=0.
!-----------------------------------------------------------------
!  Momentum flux balance:

!  UW advection d(w'w'u')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &
                         ( u(i,j,k-1)-u0(k-1)+u(i,j,k)-u0(k))*wgtw(j,k)*terraw(i,j,k)
	  end do
	 end do
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 shearx(k)=momleadv(k,1)-coef
	 momleadv(k,1)=coef
	end do	


!  VW advection d(w'w'v')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &	
                         ( v(i,j,k-1)-v0(k-1)+v(i,j,k)-v0(k))*wgtw(j,k)*terraw(i,j,k)
	  end do
	 end do
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 sheary(k)=momleadv(k,2)-coef
	 momleadv(k,2)=coef
	end do	

!  UW advection d(p'u')/dz:

	do k=1,nz
	 fadv(k)=0.
	 if(k.eq.1) then
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+(1.5*(u(i,j,k)-u0(k))*(pp(i,j,k)-pres(k))*100.- &
                     0.5*(u(i,j,k+1)-u0(k+1))*(pp(i,j,k+1)-pres(k+1))*100.)*wgtw(j,k)*terraw(i,j,k)
	    end do
	   end do
	 else if(k.eq.nz) then
	   do j=1,ny
	    do i=1,nx
	     fadv(k)=fadv(k)+(1.5*(u(i,j,k-1)-u0(k-1))*(pp(i,j,k-1)-pres(k-1))*100.- &
                  0.5*(u(i,j,k-2)-u0(k-2))*(pp(i,j,k-2)-pres(k-2))*100.)*wgtw(j,k-1)*terraw(i,j,k-1)
	    end do
	   end do
	 else
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+0.5*((u(i,j,k)-u0(k))*(pp(i,j,k)-pres(k))*100.+ &
                       (u(i,j,k-1)-u0(k-1))*(pp(i,j,k-1)-pres(k-1))*100.)*wgtw(j,k)*terraw(i,j,k)
	    end do
	   end do
	 end if
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 presx(k)=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	end do	


!  VW advection d(p'v')/dz:

	do k=1,nz
	 fadv(k)=0.
	 if(k.eq.1) then
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+(1.5*(v(i,j,k)-v0(k))*(pp(i,j,k)-pres(k))*100.- & 
                    0.5*(v(i,j,k+1)-v0(k+1))*(pp(i,j,k+1)-pres(k+1))*100.)*wgtw(j,k+1)*terraw(i,j,k+1)
	    end do
	   end do
	 else if(k.eq.nz) then
	   do j=1,ny
	    do i=1,nx
             fadv(k)=fadv(k)+(1.5*(v(i,j,k-1)-v0(k-1))*(pp(i,j,k-1)-pres(k-1))*100.- &
                     0.5*(v(i,j,k-2)-v0(k-2))*(pp(i,j,k-2)-pres(k-2))*100.)*wgtw(j,k-1)*terraw(i,j,k-1)
	    end do
	   end do
	 else
	   do j=1,ny
	    do i=1,nx
	      fadv(k)=fadv(k)+0.5*((v(i,j,k)-v0(k))*(pp(i,j,k)-pres(k))*100.+ &
                       (v(i,j,k-1)-v0(k-1))*(pp(i,j,k-1)-pres(k-1))*100.)*wgtw(j,k)*terraw(i,j,k)
	    end do
	   end do
	 end if
	 fadv(k)=fadv(k)*factor_xy
	end do
	do k=1,nzm
	 presy(k)=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	end do	

	do k=1,nzm
	  momlepress(k,1)=momlepress(k,1)-presx(k)
	  momlepress(k,2)=momlepress(k,2)-presy(k)
	  momlepress(k,3)=momlepress(k,3)-tkelepress(k)
	end do

	call hbuf_put('WUADV',momleadv(1,1),1.)
	call hbuf_put('WUANIZ',momlepress(1,1),1.)
	call hbuf_put('WUBUOY',momlebuoy(1,1),1.)
	call hbuf_put('WUSHEAR',shearx,1.)
	call hbuf_put('WUPRES',presx,1.)
	call hbuf_put('WUDIFF',momlediff(1,1),1.)

	call hbuf_put('WVADV',momleadv(1,2),1.)
	call hbuf_put('WVANIZ',momlepress(1,2),1.)
	call hbuf_put('WVBUOY',momlebuoy(1,2),1.)
	call hbuf_put('WVSHEAR',sheary,1.)
	call hbuf_put('WVPRES',presy,1.)
	call hbuf_put('WVDIFF',momlediff(1,2),1.)

	call hbuf_put('W2BUOY',momlebuoy(1,3),2.)
	call hbuf_put('W2ADV',momleadv(1,3),2.)
	call hbuf_put('W2REDIS',momlepress(1,3),2.)
	call hbuf_put('W2PRES',tkelepress,2.)
	call hbuf_put('W2DIFF',momlediff(1,3),2.)

!-----------------------------------------------------------
! T2 and Q2 variance budget:


!       explicit dissipation of scalar variances is not computed yet
!       assume that most of contrinution of diffusion is actually dissipation - MK 
  
        q2lediss = 0.
        t2lediss = 0.
	do k=1,nzm
	  q2lediff(k)=q2lediff(k)-q2lediss(k)
	  t2lediff(k)=t2lediff(k)-t2lediss(k)
	end do	
	

	call hbuf_put('T2ADVTR',t2leadv,1.)
	call hbuf_put('T2GRAD',t2legrad,1.)
	call hbuf_put('T2DISSIP',t2lediss,1.)
	call hbuf_put('T2DIFTR',t2lediff,1.)
	call hbuf_put('T2PREC',t2leprec,1.)

	call hbuf_put('Q2ADVTR',q2leadv,1.)
	call hbuf_put('Q2GRAD',q2legrad,1.)
	call hbuf_put('Q2DISSIP',q2lediss,1.)
	call hbuf_put('Q2DIFTR',q2lediff,1.)
	call hbuf_put('Q2PREC',q2leprec,1.)

!------------------------------------------------------------------
! HW and QW budgets:


	fadv(1)=0.
	fadv(nz)=0.


!  HW advection d(w'w'h')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5* &
                 	      ( t(i,j,k-1)-t0(k-1)+t(i,j,k)-t0(k))*wgtw(j,k)*terraw(i,j,k)
	  end do
	 end do
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 twgrad(k)=twleadv(k)-coef
	 twleadv(k)=coef
	end do	


!  QW advection d(w'w'q')/dz:

	do k=2,nzm
	 fadv(k)=0.
	 do j=1,ny
	  do i=1,nx
	    fadv(k)=fadv(k)+w(i,j,k)**2*rhow(k)*0.5*wgtw(j,k)*terraw(i,j,k)* &
       	     ( qv(i,j,k-1)+qcl(i,j,k)+qci(i,j,k)-q0(k-1)+qv(i,j,k)+qcl(i,j,k)+qci(i,j,k)-q0(k))
	  end do
	 end do
	end do
	do k=1,nzm
	 coef=-(fadv(k+1)-fadv(k))/(adz(k)*dz*rho(k))
	 qwgrad(k)=qwleadv(k)-coef
	 qwleadv(k)=coef
	end do	



	call hbuf_put('TWADV',twleadv,factor_xy)
	call hbuf_put('TWDIFF',twlediff,factor_xy)
	call hbuf_put('TWGRAD',twgrad,factor_xy)
	call hbuf_put('TWBUOY',twlebuoy,factor_xy)
	call hbuf_put('TWPRES',twlepres,factor_xy)
	call hbuf_put('TWPREC',twleprec,factor_xy)

	call hbuf_put('QWADV',qwleadv,factor_xy)
	call hbuf_put('QWDIFF',qwlediff,factor_xy)
	call hbuf_put('QWGRAD',qwgrad,factor_xy)
	call hbuf_put('QWBUOY',qwlebuoy,factor_xy)
	call hbuf_put('QWPRES',qwlepres,factor_xy)
	call hbuf_put('QWPREC',qwleprec,factor_xy)

!-------------------------------------------------------------
!	Conditional statistics:
!-------------------------------------------------------------
!bloss:  Major modification of conditional statistics to allow 
         ! a standard set of averages to be defined using many
         ! different conditions.  Here, the conditions are cloudy,
         ! updraft core, downdraft core, saturated updraft, saturated
         ! downdraft and unsaturated environment.

         ! initialize mask array, which will be one only where the conditional
         !   is satisfied, and zero everywhere else.
         !   this is used in MICRO_M2005 to compute conditional averages of 
         !     microphysical transfer rates
         condavg_mask(:,:,:,:) = 0.

         do k = 1,nzm
            if(LES_S) then
               coef=0.
            else
               coef=min(1.e-5,0.01*qsatw(tabs0(k),pres(k)))
            endif
            do j = 1,ny
               do i = 1,nx
                  
                  if((icondavg_cld.gt.0).and.(qcl(i,j,k)+qci(i,j,k).gt.coef)) then
                     condavg_mask(i,j,k,icondavg_cld) = cld(i,j,k) ! cloud
                  end if

                  if(icondavg_cor.gt.0) then
                     ! updraft (w>1) core (tv'>0) statistics
                     ! in LES, buoyant cloudy statistics
                     condition_cl = qcl(i,j,k)+qci(i,j,k).gt.coef
                     condition = tvirt(i,j,k).gt.tvz(k) 
                     if(LES_S) then
                       condition=condition_cl.and.condition
                     else
                       condition=condition.and.w(i,j,k)+w(i,j,k+1).gt.2.
                     end if
                     if(condition) condavg_mask(i,j,k,icondavg_cor) = 1. ! core
                  end if

                  if(icondavg_cordn.gt.0) then
                     ! downdraft (w<-1) core (tv'>0) statistics
                     ! in LES_S, buoyant, saturated or rainy statistics
                     condition_cl = qcl(i,j,k)+qci(i,j,k).gt.coef &
                                .or. qpl(i,j,k)+qpi(i,j,k).gt.1.e-4 
                     condition = tvirt(i,j,k).lt.tvz(k) 
                     if(LES_S) then
                       condition=condition_cl.and.condition
                     else 
                       condition=condition.and.w(i,j,k)+w(i,j,k+1).lt.-2.
                     end if
                     if(condition) condavg_mask(i,j,k,icondavg_cordn) = 1. ! downdraft core
                  end if


                  condition_cl = qcl(i,j,k)+qci(i,j,k).gt.coef
                  if((icondavg_satup.gt.0).AND. &
                       (condition_cl.AND.w(i,j,k)+w(i,j,k+1).ge.0.)) then
                     condavg_mask(i,j,k,icondavg_satup) = 1. ! saturated updraft
                  end if

                  if((icondavg_satdn.gt.0).AND. &
                       (condition_cl.AND.w(i,j,k)+w(i,j,k+1).lt.0.)) then
                     condavg_mask(i,j,k,icondavg_satdn) = 1. ! saturated downdraft
                  end if

                  if((icondavg_env.gt.0).AND.(.NOT.condition_cl)) then
                     condavg_mask(i,j,k,icondavg_env) = 1. ! cloud-free environment
                  end if

               end do
            end do
         end do
            
         do ncond = 1,ncondavg
            clds(:) = 0.
            wcl(:) = 0.
            ucl(:) = 0.
            vcl(:) = 0.
            wacl(:) = 0.
            tcl(:) = 0.
            tacl(:) = 0.
            tvcl(:)= 0.
            tvcla(:)= 0.
            qcll(:) = 0.
            qccl(:)= 0.
            qicl(:)= 0.
            qpcl(:)= 0.
            tvwcl(:)= 0.
            twcl(:)= 0.
            qwcl(:)= 0.
            qcwcl(:)= 0.
            qiwcl(:)= 0.
            dse(:)=0.
            mse(:)=0.
            sse(:)=0.

            !bloss: conditional u,v anomalies
            ucla(:) = 0. 
            vcla(:) = 0.

            !bloss: pressure gradients
            dpdxcl(:) = 0.
            dpdycl(:) = 0.
            dpdzcl(:) = 0.

            !bloss: add momentum fluxes
            uwsbcl(:) = 0. 
            vwsbcl(:) = 0.
            uwlecl(:) = 0.
            vwlecl(:) = 0.

            !bloss: frozen moist static energy
            fmse(:) = 0.
            fmsecla(:) = 0.

            !bloss: mass flux and mass-flux weighted stats in conditional category
            rhowcl(:) = 0.

            rhowmsecl(:) = 0.
            rhowtlcl(:) = 0. 
            rhowqtcl(:) = 0. 
            rhowtvcl(:) = 0. 

            rhowmsecla(:) = 0.
            rhowqtcla(:) = 0. 
            rhowtlcla(:) = 0. 
            rhowtvcla(:) = 0. 

            rhouwcl(:) = 0.
            rhovwcl(:) = 0.
            rhowwcl(:) = 0.

            do k=1,nzm
               if(LES_S) then
                  coef=0.
               else
                  coef=min(1.e-5,0.01*qsatw(tabs0(k),pres(k)))
               endif
               kb = max(1,k-1)
               kc = min(nzm,k+1)
               do j=1,ny
                  jb = YES3D*(j-1) + (1-YES3D)
                  do i=1,nx

                     if(condavg_mask(i,j,k,ncond).gt.0) then

                        ! gather conditional statistics
                        www = wgt(j,k)*terra(i,j,k)
                        clds(k)=clds(k) + cld(i,j,k)*www
                        tmp(1)=0.5*(w(i,j,k+1)*wgtw(j,k+1)*terraw(i,j,k+1)+w(i,j,k)*wgtw(j,k)*terraw(i,j,k))
                        wcl(k) = wcl(k) + tmp(1)
                        ucl(k) = ucl(k) + (u(i,j,k) + ug)*wgtu(j,k)*terrau(i,j,k) !bloss: include ground speed
                        vcl(k) = vcl(k) + (v(i,j,k) + vg)*wgtv(j,k)*terrav(i,j,k)
                        ucla(k) = ucla(k) + (u(i,j,k) - u0(k))*wgtu(j,k)*terrau(i,j,k) !bloss: u,v anomalies
                        vcla(k) = vcla(k) + (v(i,j,k) - v0(k))*wgtv(j,k)*terrav(i,j,k)
                        qcc=qcl(i,j,k)
                        qii=qci(i,j,k)
                        dse(k)=dse(k)+(tabs(i,j,k)+gamaz(k))*www
                        mse(k)=mse(k)+(tabs(i,j,k)+gamaz(k)+fac_cond*qv(i,j,k))*www
                        tcl(k) = tcl(k) + t(i,j,k)*www
                        qcll(k) = qcll(k) + (qv(i,j,k)+qcl(i,j,k)+qci(i,j,k))*www
                        qccl(k) = qccl(k) + qcc*www
                        qicl(k) = qicl(k) + qii*www
                        qpcl(k) = qpcl(k) + (qpl(i,j,k) + qpi(i,j,k))*www
                        tvcl(k) = tvcl(k) + tvirt(i,j,k)*www 
                        tvcla(k) = tvcla(k) + (tvirt(i,j,k) - tvz(k))*www
                        tacl(k) = tacl(k) + tabs(i,j,k)*www 
                        twcl(k) = twcl(k) + t(i,j,k)*0.5*(w(i,j,k+1)+w(i,j,k))*www
                        qwcl(k) = qwcl(k) + (qv(i,j,k)+qcl(i,j,k)+qci(i,j,k))*0.5*(w(i,j,k+1)+w(i,j,k))*www
                        tvwcl(k) = tvwcl(k)+tvirt(i,j,k)*0.5*(w(i,j,k+1)+w(i,j,k))*www
                        qcwcl(k) = qcwcl(k) + qcc*0.5*(w(i,j,k+1)+w(i,j,k))*www
                        qiwcl(k) = qiwcl(k) + qii*0.5*(w(i,j,k+1)+w(i,j,k))*www

                        !bloss: frozen MSE and anomaly
                        fmse(k)=fmse(k)+(t(i,j,k)+fac_cond*(qv(i,j,k)+qcl(i,j,k) &
                                         +qci(i,j,k)+qpl(i,j,k)+qpi(i,j,k)))*www
                        fmsecla(k)=fmsecla(k)+(t(i,j,k)-t0(k) &
                             +fac_cond*(qv(i,j,k)+qcl(i,j,k)+qci(i,j,k)+qpl(i,j,k) &
                                         +qpi(i,j,k)-q0(k)-qp0(k)))*www

                        !bloss: pressure gradient forces
                        dpdxcl(k) = dpdxcl(k) - (pp(i,j,k)-pp(i-1,j,k))*100./dx*wgtu(j,k)*terrau(i,j,k)
                        dpdycl(k) = dpdycl(k) - (pp(i,j,k)-pp(i,jb,k))*100./(dy*adyv(j))*wgtv(j,k)*terrav(i,j,k)
                        dpdzcl(k) = dpdzcl(k) - & 
                             ( 0.5*(pp(i,j,kc)-pres(kc)-pp(i,j,k)+pres(k))*100./(dz*adzw(kc)) &
                             + 0.5*(pp(i,j,k)-pres(k)-pp(i,j,kb)+pres(kb))*100./(dz*adzw(k)))*wgt(j,k)*terra(i,j,k)

                        !bloss: add momentum fluxes
                        if(k.eq.1) then
                           ! surface momentum flux anomaly
                           uwsubgrid = fluxbu(i,j) !surface momentum flux/drag
                           vwsubgrid = fluxbv(i,j) !surface momentum flux/drag

                           uwresolved = 0. ! no resolved momentum flux at surface
                           vwresolved = 0. ! no resolved momentum flux at surface

                        else              
                           ! momentum flux anomaly above surface

                           ! subgrid
               !            uwsubgrid = -(0.25*grdf_z(k-1)/dz) &
               !                 *(tk(i,j,k-1)+tk(i-1,j,k-1)+tk(i,j,k)+tk(i-1,j,k)) &
               !                 *( (u(i,j,k)-u(i,j,k-1))/adzw(k) &
               !                   + (w(i,j,k)-w(i-1,j,k))*dz/dx)
               !            vwsubgrid = -(0.25*grdf_z(k-1)/dz) &
               !                 *(tk(i,j,k-1)+tk(i,jb,k-1)+tk(i,j,k)+tk(i,jb,k)) &
               !                 *( (v(i,j,k)-v(i,j,k-1))/adzw(k) &
               !                   + (w(i,j,k)-w(i,jb,k))*dz/(dy*ady(j))

                            uwsubgrid = 0.
                            vwsubgrid = 0.
                           ! resolved
                           uwresolved = 0.25*(w(i,j,k)+w(i-1,j,k)) &
                                *(u(i,j,k)+u(i,j,k-1)-u0(k)-u0(k-1))*wgtu(j,k)*terrau(i,j,k)
                           vwresolved = 0.25*(w(i,j,k)+w(i,jb,k)) &
                                *(v(i,j,k)+v(i,j,k-1)-v0(k)-v0(k-1))*wgtv(j,k)*terrav(i,j,k)
                        end if

                        uwsbcl(k) = uwsbcl(k) + uwsubgrid
                        vwsbcl(k) = vwsbcl(k) + vwsubgrid
                        uwlecl(k) = uwlecl(k) + uwresolved + uwsubgrid
                        vwlecl(k) = vwlecl(k) + vwresolved + vwsubgrid

                        !bloss: add mass flux and mass flux weighted stats
                        tmprhow = 0.5*rho(k)*(w(i,j,k+1) + w(i,j,k))
                        tmpmse = t(i,j,k) &
                             + fac_cond*(qv(i,j,k) + qcl(i,j,k) + qci(i,j,k) &
                             + qpl(i,j,k) + qpi(i,j,k))
                        tmpqt = qv(i,j,k) + qcl(i,j,k) + qci(i,j,k)

                        rhowcl(k) = rhowcl(k) + tmprhow
                        rhowmsecl(k) = rhowmsecl(k) + tmprhow*tmpmse
                        rhowmsecla(k) = rhowmsecla(k) &
                             + tmprhow*(tmpmse - t0(k) - fac_cond*(q0(k) + qp0(k)))*www
                        rhowqtcl(k) = rhowqtcl(k) + tmprhow*tmpqt*www
                        rhowqtcla(k) = rhowqtcla(k) + tmprhow*(tmpqt-q0(k))*www
                        rhowtlcl(k) = rhowtlcl(k) + tmprhow*(t(i,j,k))*www
                        rhowtlcla(k) = rhowtlcla(k) + tmprhow*(t(i,j,k)-t0(k))*www
                        rhowtvcl(k) = rhowtvcl(k) + tmprhow*tvirt(i,j,k)*www
                        rhowtvcla(k) = rhowtvcla(k) + tmprhow*(tvirt(i,j,k)-tvz(k))*www

                        rhouwcl(k) = rhouwcl(k) + tmprhow*(u(i,j,k) - u0(k))*www
                        rhovwcl(k) = rhovwcl(k) + tmprhow*(v(i,j,k) - v0(k))*www
                        rhowwcl(k) = rhowwcl(k) + rho(k)*0.5*(w(i,j,k)**2 + w(i,j,k+1)**2)*www

                     endif
                  end do
               end do
               condavg_factor(k,ncond) = condavg_factor(k,ncond)+clds(k)
               wacl(k) = wcl(k)

            end do

            call hbuf_put(TRIM(condavgname(ncond)),clds,factor_xy)
            call hbuf_put('W'//TRIM(condavgname(ncond)),wcl,1.)
            call hbuf_put('U'//TRIM(condavgname(ncond)),ucl,1.)
            call hbuf_put('V'//TRIM(condavgname(ncond)),vcl,1.)
            call hbuf_put('DSE'//TRIM(condavgname(ncond)),dse,1.)
            call hbuf_put('MSE'//TRIM(condavgname(ncond)),mse,1.)
            call hbuf_put('TL'//TRIM(condavgname(ncond)),tcl,1.)
            call hbuf_put('TV'//TRIM(condavgname(ncond)),tvcl,1.)
            call hbuf_put('TV'//TRIM(condavgname(ncond))//'A',tvcla,1.)
            call hbuf_put('TA'//TRIM(condavgname(ncond)),tacl,1.)
            call hbuf_put('QT'//TRIM(condavgname(ncond)),qcll,1.e3)
            !bloss               call hbuf_put('QC'//TRIM(condavgname(ncond)),qccl,1.e3)
            !bloss               call hbuf_put('QI'//TRIM(condavgname(ncond)),qicl,1.e3)
            call hbuf_put('QN'//TRIM(condavgname(ncond)),qccl+qicl,1.e3)
            call hbuf_put('QP'//TRIM(condavgname(ncond)),qpcl,1.e3)
            call hbuf_put('W'//TRIM(condavgname(ncond))//'A',wacl,factor_xy)
            call hbuf_put('TLW'//TRIM(condavgname(ncond)),twcl,factor_xy)
            call hbuf_put('TVW'//TRIM(condavgname(ncond)),tvwcl,factor_xy)
            call hbuf_put('QTW'//TRIM(condavgname(ncond)),qwcl,factor_xy*1.e3)
            call hbuf_put('QCW'//TRIM(condavgname(ncond)),qcwcl,factor_xy*1.e3)
            call hbuf_put('QIW'//TRIM(condavgname(ncond)),qiwcl,factor_xy*1.e3)

            !bloss: add mass flux and mass-flux weighted MSE/QT/TV and anomalies
            call hbuf_put('MF'//TRIM(condavgname(ncond)),rhowcl,factor_xy)

            call hbuf_put('MFH'//TRIM(condavgname(ncond)),rhowmsecl,factor_xy)
            call hbuf_put('MFTL'//TRIM(condavgname(ncond)),rhowtlcl,factor_xy)
            call hbuf_put('MFQT'//TRIM(condavgname(ncond)),rhowqtcl,factor_xy*1.e3)
            call hbuf_put('MFTV'//TRIM(condavgname(ncond)),rhowtvcl,factor_xy)

            call hbuf_put('RUW'//TRIM(condavgname(ncond)),rhouwcl,factor_xy)
            call hbuf_put('RVW'//TRIM(condavgname(ncond)),rhovwcl,factor_xy)
            call hbuf_put('RWW'//TRIM(condavgname(ncond)),rhowwcl,factor_xy)

            call hbuf_put('MFH'//TRIM(condavgname(ncond))//'A',rhowmsecla,factor_xy)
            call hbuf_put('MFTL'//TRIM(condavgname(ncond))//'A',rhowtlcla,factor_xy)
            call hbuf_put('MFQT'//TRIM(condavgname(ncond))//'A',rhowqtcla,factor_xy*1.e3)
            call hbuf_put('MFTV'//TRIM(condavgname(ncond))//'A',rhowtvcla,factor_xy)

            !bloss: add momentum fluxes and horizontal velocity anomalies
            call hbuf_put('UW'//TRIM(condavgname(ncond)),uwlecl,1.)
            call hbuf_put('VW'//TRIM(condavgname(ncond)),vwlecl,1.)
            call hbuf_put('UWSB'//TRIM(condavgname(ncond)),uwsbcl,1.)
            call hbuf_put('VWSB'//TRIM(condavgname(ncond)),vwsbcl,1.)
            call hbuf_put('U'//TRIM(condavgname(ncond))//'A',ucla,1.)
            call hbuf_put('V'//TRIM(condavgname(ncond))//'A',vcla,1.)

            !bloss: frozen moist static energy
            call hbuf_put('HF'//TRIM(condavgname(ncond)),fmse,1.)
            call hbuf_put('HF'//TRIM(condavgname(ncond))//'A',fmsecla,1.)

            !bloss: pressure gradient forces
            call hbuf_put('UPGF'//TRIM(condavgname(ncond)),dpdxcl,1.)
            call hbuf_put('VPGF'//TRIM(condavgname(ncond)),dpdycl,1.)
            call hbuf_put('WPGF'//TRIM(condavgname(ncond)),dpdzcl,1.)

         end do ! ncond = 1,ncondstats

!-------------------------------------------------------------
!	Mass flux, hydrometeor fraction statistics
!-------------------------------------------------------------

	do k=1,nzm

	 hydro(k) = 0.
	 prof1(k)=0.
	 prof2(k)=0.
	 prof3(k)=0.
	 prof4(k)=0.
	 if(LES_S) then
	  coef=0.
	 else
	  coef=min(1.e-5,0.01*qsatw(tabs0(k),pres(k)))
	 endif
	 do j=1,ny
	  do i=1,nx
	    if(qcl(i,j,k)+qci(i,j,k).gt.coef) then
	      hydro(k) = hydro(k) + wgt(j,k)*terra(i,j,k)
	      tmp(1)=0.5*(w(i,j,k+1)+w(i,j,k))
	      if(tmp(1).gt.0.) then
		prof1(k)=prof1(k)+rho(k)*tmp(1)*wgt(j,k)*terra(i,j,k)
	      else
	        prof2(k)=prof2(k)+rho(k)*tmp(1)*wgt(j,k)*terra(i,j,k)
	      endif	
	    elseif(qpl(i,j,k)+qpi(i,j,k).gt.1.e-4) then
	      hydro(k) = hydro(k) + wgt(j,k)*terra(i,j,k)
	      if(w(i,j,k)+w(i,j,k+1).lt.0.) &
 	         prof3(k)=prof3(k)+rho(k)*0.5*(w(i,j,k+1)+w(i,j,k))*wgt(j,k)*terra(i,j,k)      
	    endif
	  end do
	 end do
	 prof4(k)=prof1(k)+prof2(k)+prof3(k)

	end do
		
	call hbuf_put('HYDRO',hydro,factor_xy)
	call hbuf_put('MCUP',prof1,factor_xy)
	call hbuf_put('MCDNS',prof2,factor_xy)
	call hbuf_put('MCDNU',prof3,factor_xy)
	call hbuf_put('MC',prof4,factor_xy)

!-------------------------------------------------------------
!	Updraft Core statistics:
!-------------------------------------------------------------


	do k=1,nzm
	 cldd(k) = 0.
	 prof1(k)=0.
         if(LES_S) then
          coef=0.
         else
          coef=min(1.e-5,0.01*qsatw(tabs0(k),pres(k)))
         endif
	 do j=1,ny
	  do i=1,nx
	    condition_cl = qcl(i,j,k)+qci(i,j,k).gt.coef
     	    condition = tvirt(i,j,k).gt.tvz(k) 
            if(LES_S) then
             condition=condition_cl.and.condition
	    else
              condition=condition.and.w(i,j,k)+w(i,j,k+1).gt.2.
            end if
	    if(condition) then
	      prof1(k)=prof1(k)+rho(k)*0.5*(w(i,j,k+1)+w(i,j,k))*wgt(j,k)*terra(i,j,k)      
	      if(condition_cl) then
	        cldd(k)=cldd(k)+cld(i,j,k)*wgt(j,k)*terra(i,j,k)
	      end if
	    endif
	  end do
	 end do
	end do
		
	call hbuf_put('CORECL',cldd,factor_xy)
!-------------------------------------------------------------
!	Cloud Downdraft Core statistics:
!-------------------------------------------------------------


	do k=1,nzm
	 cldd(k) = 0.
	 prof2(k)=0.
	 prof3(k)=0.
         if(LES_S) then
          coef=0.
         else
          coef=min(1.e-5,0.01*qsatw(tabs0(k),pres(k)))
         endif
	 do j=1,ny
	  do i=1,nx
	    condition_cl = qcl(i,j,k)+qci(i,j,k).gt.coef .or. qpl(i,j,k)+qpi(i,j,k).gt.1.e-4 
     	    condition = tvirt(i,j,k).lt.tvz(k) 
	    if(LES_S) then
             condition=condition_cl.and.condition
	    else
             condition=condition.and.w(i,j,k)+w(i,j,k+1).lt.-2.
            end if
	    if(condition) then
	      if(condition_cl) then
	        prof2(k)=prof2(k)+rho(k)*0.5*(w(i,j,k+1)+w(i,j,k))*wgt(j,k)*terra(i,j,k)      
	        cldd(k)=cldd(k) + cld(i,j,k)*wgt(j,k)*terra(i,j,k)
	      else
	        prof3(k)=prof3(k)+rho(k)*0.5*(w(i,j,k+1)+w(i,j,k))*wgt(j,k)*terra(i,j,k)      
	      end if
	    endif
	  end do
	 end do
	 prof4(k)=prof1(k)+prof2(k)+prof3(k)

	end do
		
	call hbuf_put('COREDNCL',cldd,factor_xy)
	call hbuf_put('MCRUP',prof1,factor_xy)
	call hbuf_put('MCRDNS',prof2,factor_xy)
	call hbuf_put('MCRDNU',prof3,factor_xy)
	call hbuf_put('MCR',prof4,factor_xy)

!---------------------------------------------------------
!  Radiation and other stuff

	do j=1,ny
	 do i=1,nx
	   cwpt(i,j)=0.
	   cwpl(i,j)=0.
	   cwpm(i,j)=0.
	   cwph(i,j)=0.
	   topind(i,j)=1
           z_inv_ind(i,j)=1
           z_base_ind(i,j)=0
           z_top_ind(i,j)=0
           grad_max(i,j) = 0.
	 end do
	end do
	
	if(.not.LES_S) then
	  cwpmax=cwp_threshold
	else
	  cwpmax=0.0
	endif

        acldl = 0.
        acldm = 0.
        acldh = 0.
        acld = 0.
	do k=nzm,1,-1
	 prof1(k)=(radqrlw(k)+radqrsw(k))*factor_xy
	 tmp(1)=rho(k)*adzw(k)*dz
         kc = min(nzm,k+1)
         kb = max(1,k-1)
         tmp(2)=1./(z(kc)-z(kb))
	 do j=1,ny
	  do i=1,nx
            if(z(k).lt.4000.) then ! shallow clouds only
               ! find height of max pot. temp. vert gradient (inversion height) 
               grad = (t(i,j,kc)-t(i,j,kb))*tmp(2)
               if(grad_max(i,j).lt.grad)then
                 grad_max(i,j) = grad
                 z_inv_ind(i,j)=k
               end if
            end if
	    cwpt(i,j)=cwpt(i,j)+tmp(1)*(qcl(i,j,k)+qci(i,j,k))
            if(docup) then
	      acld= max(acld,cld(i,j,k)) 
              if(pres(k).ge.700.) then
	        acldl= max(acldl,cld(i,j,k))*wgt(j,k)*terra(i,j,k)
              else if(pres(k).le.400.) then
	        acldh= max(acldh,cld(i,j,k))*wgt(j,k)*terra(i,j,k)
              else
	        acldm= max(acldm,cld(i,j,k))*wgt(j,k)*terra(i,j,k) 
	      end if
            end if
            if(pres(k).ge.700.) then
	      cwpl(i,j)=cwpl(i,j)+tmp(1)*(qcl(i,j,k)+qci(i,j,k))*wgt(j,k)*terra(i,j,k)
            else if(pres(k).le.400.) then
	      cwph(i,j)=cwph(i,j)+tmp(1)*(qcl(i,j,k)+qci(i,j,k))*wgt(j,k)*terra(i,j,k)
            else
	      cwpm(i,j)=cwpm(i,j)+tmp(1)*(qcl(i,j,k)+qci(i,j,k))*wgt(j,k)*terra(i,j,k)
	    end if
	    if(cwpt(i,j).gt.cwpmax.and.topind(i,j).eq.1)topind(i,j)=k
	  end do
	 end do
	end do
        if(docup) then
         s_acld = s_acld + acld
         s_acldl = s_acldl + acldl
         s_acldm = s_acldm + acldm
         s_acldh = s_acldh + acldh
        end if

        ncloud = 0
        do k=1,nzm
         do j=1,ny
          do i=1,nx
            if(z_base_ind(i,j).eq.0.and.qcl(i,j,k).gt.0.)then
                z_base_ind(i,j)=k
                ncloud = ncloud+1
            end if
            if(qcl(i,j,k).gt.0.) then
                z_top_ind(i,j)=k
            end if
          end do
         end do
        end do
        if(ncloud.eq.0) then
         coef = 0.
        else
         coef = float(nx*ny)/float(ncloud)
         ncloudy = ncloudy+1
        end if

	do j=1,ny
	 do i=1,nx
           if(.not.docup) then 
	     if(cwpt(i,j).gt.cwpmax) s_acld=s_acld+wgty(j)
	     if(cwpl(i,j).gt.cwpmax) s_acldl=s_acldl+wgty(j)
	     if(cwpm(i,j).gt.cwpmax) s_acldm=s_acldm+wgty(j)
	     if(cwph(i,j).gt.cwpmax) s_acldh=s_acldh+wgty(j)
	     if(tabs(i,j,topind(i,j)).lt.245.) s_acldcold=s_acldcold+wgty(j)
           end if
           s_sst = s_sst + sstxy(i,j)*wgty(j)
           zzz = z(z_inv_ind(i,j))*0.001
           z_inv = z_inv + zzz*wgty(j)
           z2_inv = z2_inv + zzz**2*wgty(j)
           cwpmean = cwpmean + cwpt(i,j)*wgty(j)
           cwp2 = cwp2 + cwpt(i,j)**2*wgty(j)
           if(z_base_ind(i,j).gt.0) then
             z_cbmn = z_cbmn + z(z_base_ind(i,j))*0.001*coef*wgty(j)
             z2_cb = z2_cb + (z(z_base_ind(i,j))*0.001)**2*coef*wgty(j)
             z_cb = min(z_cb,z(z_base_ind(i,j))*0.001)
           end if
           if(z_top_ind(i,j).gt.0) then
             z_ctmn = z_ctmn + z(z_top_ind(i,j))*0.001*coef*wgty(j)
             z2_ct = z2_ct + (z(z_top_ind(i,j))*0.001)**2*coef*wgty(j)
             z_ct = max(z_ct,z(z_top_ind(i,j))*0.001)
           end if
           s_t2m = s_t2m +t2m(i,j)*wgty(j)
           s_q2m = s_q2m +q2m(i,j)*wgty(j)
           s_u10m = s_u10m +u10m(i,j)*wgty(j)
           s_v10m = s_v10m +v10m(i,j)*wgty(j)
           if(SLM) then
            s_snowd = s_snowd +snow_mass(i,j)/rho_snow*wgty(j)
            s_snowt = s_snowt +snowt(i,j)*wgty(j)
            s_lhfc = s_lhfc +lhf_canop(i,j)*wgty(j)
            s_shfc = s_shfc +shf_canop(i,j)*wgty(j)
            s_lhfs = s_lhfs +lhf_soil(i,j)*wgty(j)
            s_shfs = s_shfs +shf_soil(i,j)*wgty(j)
            s_tsoil = s_tsoil +soilt(1,i,j)*wgty(j)
            s_tcanopy = s_tcanopy +t_canop(i,j)*wgty(j)
            s_soilflux = s_soilflux +soilflux(i,j)*wgty(j)
           end if
           k = k_terra(i,j)
           s_shf = s_shf + rhow(k)*cp*fluxbt(i,j)*wgty(j)
           s_lhf = s_lhf + rhow(k)*lcond*fluxbq(i,j)*wgty(j)
	 end do
	end do

	do k=1,nzm
	 prof2(k)=0.
	 prof3(k)=0.	 
	 n=0
	 if(dolongwave.or.doshortwave) then
	   do j=1,ny
	     do i=1,nx
	       if(cwpt(i,j).gt.cwpmax) then
	         n=n+1
	         prof2(k)=prof2(k)+qrad(i,j,k)
	       else
	         prof3(k)=prof3(k)+qrad(i,j,k)
	       endif
	     end do
	   end do 
	 end if
	end do


	call hbuf_put('HLADV',tadv,factor_xy*86400./dtn)
	call hbuf_put('HLDIFF',tdiff,factor_xy*86400./dtn)
	call hbuf_put('HLLAT',tlat+tlatqi+tlatqc,factor_xy*86400./dtn)
	call hbuf_put('HLRAD',prof1,86400.)


        if(dotracers) then
          do ntr=1,ntracers
           call hbuf_avg_put(trim(tracername(ntr)),tracer(:,:,:,ntr), &
                                     dimx1_s,dimx2_s,dimy1_s,dimy2_s,nzm,1.)
           call hbuf_put(trim(tracername(ntr))//'FLX',trwle(:,ntr),factor_xy)
           call hbuf_put(trim(tracername(ntr))//'FLXS',trwsb(:,ntr),factor_xy)
           call hbuf_put(trim(tracername(ntr))//'ADV',tradv(:,ntr),factor_xy*86400./dtn)
           call hbuf_put(trim(tracername(ntr))//'DIFF',trdiff(:,ntr),factor_xy*86400./dtn)
           call hbuf_put(trim(tracername(ntr))//'PHYS',trphys(:,ntr),factor_xy*86400./dtn)
          end do
        end if


	call hbuf_put('RADLWUP',radlwup,factor_xy)
	call hbuf_put('RADLWDN',radlwdn,factor_xy)
	call hbuf_put('RADSWUP',radswup,factor_xy)
	call hbuf_put('RADSWDN',radswdn,factor_xy)
	call hbuf_put('RADQRLW',radqrlw,factor_xy*86400.) 	
	call hbuf_put('RADQRSW',radqrsw,factor_xy*86400.) 	
	call hbuf_put('RADQRCLW',radqrclw,factor_xy*86400.) 	
	call hbuf_put('RADQRCSW',radqrcsw,factor_xy*86400.) 	
	call hbuf_put('RADQR',prof1,86400.) 	
	call hbuf_put('RADQRC',prof2,86400./(n+1.e-5)) 	
	call hbuf_put('RADQRS',prof3,86400./(nx*ny-n+1.e-5))

!---------------------------------------------------------
!  Apparent heat/moisture sources/sinks

	tmp(1)=1./dtn

	do k=1,nzm
	 prof2(k)=0.
	 prof3(k)=0.	 
	 n=0
	 do j=1,ny
	  do i=1,nx
	    prof2(k)=prof2(k)+(tabs(i,j,k)-t01(k))*tmp(1)-ttend(k)-prof1(k)
	    prof3(k)=prof3(k)-fac_cond*((qv(i,j,k)+qcl(i,j,k)+qci(i,j,k)-q01(k))*tmp(1)-qtend(k))
	  end do
	 end do 
	end do

	call hbuf_put('Q1C',prof2,factor_xy*86400.) 	
	call hbuf_put('Q2',prof3,factor_xy*86400.) 	

        if(docloud) call compute_instr_diags()

!===================================================
! UW ADDITIONS
        ! compute storage terms
        ustor(:) = (u0(1:nzm) - ustor(:))/dt/float(nstatis)
        vstor(:) = (v0(1:nzm) - vstor(:))/dt/float(nstatis)
        tstor(:) = (t0(1:nzm) - tstor(:))/dt/float(nstatis)
        qstor(:) = (q0(1:nzm) - qstor(:))/dt/float(nstatis)

	call hbuf_put('USTOR',ustor,86400.)
	call hbuf_put('VSTOR',vstor,86400.)
	call hbuf_put('HLSTOR',tstor,86400.)
	call hbuf_put('QTSTOR',qstor,86400.*1.e3)

        !bloss: extra nudging/vertical large-scale advective tendency outputs
	call hbuf_put('TVTEND',tlsvadv,86400.)
	call hbuf_put('QVTEND',qlsvadv,86400.*1.e3)
	call hbuf_put('THTEND',ttend-tlsvadv,86400.)
	call hbuf_put('QHTEND',qtend-qlsvadv,86400.*1.e3)
	call hbuf_put('TNUDGE',tnudge,86400.)
	call hbuf_put('QNUDGE',qnudge,86400.*1.e3)

	call hbuf_put('ULSADVV',ulsvadv,86400.)
	call hbuf_put('VLSADVV',vlsvadv,86400.)
	call hbuf_put('UNUDGE',unudge,86400.)
	call hbuf_put('VNUDGE',vnudge,86400.)

        !bloss: add outputs for resolved and subgrid momentum tendencies

        ! subgrid tendencies
        udiff(1:nzm) = &
             (rhow(1:nzm)*uwsb(1:nzm) - rhow(2:nz)*uwsb(2:nz)) &
             /rho(1:nzm)/dz/adz(1:nzm)
        vdiff(1:nzm) = &
             (rhow(1:nzm)*vwsb(1:nzm) - rhow(2:nz)*vwsb(2:nz)) &
             /rho(1:nzm)/dz/adz(1:nzm)

        ! resolved tendencies
        uadv(1:nzm) = & 
             (rhow(1:nzm)*uwle(1:nzm) - rhow(2:nz)*uwle(2:nz)) &
             /rho(1:nzm)/dz/adz(1:nzm) - udiff(1:nzm)
        vadv(1:nzm) = & 
             (rhow(1:nzm)*vwle(1:nzm) - rhow(2:nz)*vwle(2:nz)) &
             /rho(1:nzm)/dz/adz(1:nzm) - vdiff(1:nzm)

	call hbuf_put('UADV',uadv,factor_xy*86400.)
	call hbuf_put('VADV',vadv,factor_xy*86400.)
	call hbuf_put('UDIFF',udiff,factor_xy*86400.)
	call hbuf_put('VDIFF',vdiff,factor_xy*86400.)

        ! coriolis accelerations
        call hbuf_put('UTENDCOR',utendcor,factor_xy*86400.)
	call hbuf_put('VTENDCOR',vtendcor,factor_xy*86400.)

        ! momentum budget residual
        call hbuf_put('URESID',ustor-factor_xy*(utendcor+uadv+udiff)-unudge-ulsvadv,1.)
        call hbuf_put('VRESID',vstor-factor_xy*(vtendcor+vadv+vdiff)-vnudge-vlsvadv,1.)

        !bloss: set up storage terms for next time
        ustor(:) = u0(1:nzm)
        vstor(:) = v0(1:nzm)
        tstor(:) = t0(1:nzm)
        qstor(:) = q0(1:nzm)

! END UW ADDITIONS
!===================================================

        if(dobuildings) call buildings_stat()

!-----------------------------------------------------

        dts = 0.
        dtst = 0.

        call t_stopf('statistics')

end


! function to aid computation of various water paths statistics

real(8) function water_sum(q)

  use grid, only: wgty,nx,ny,nzm,nx_gl,ny_gl
  use vars, only : adz,dz,rho
  use terrain, only: terra
  implicit none
  real, intent(in) :: q(nx,ny,nzm)
  real(8) tmp
  integer i,j,k

  water_sum = 0.
  do k=1,nzm
    tmp = 0.
    do j=1,ny
      do i=1,nx
        tmp = tmp + q(i,j,k)*wgty(j)*terra(i,j,k)
      end do
    end do
    water_sum = water_sum + tmp*adz(k)*dz*rho(k)
  end do

end function water_sum


