c
c This program rewrite the compressed *.tar file with 3D fields
c generated by the model into the netcdf file.
c
c (C) 1999 Marat Khairoutdinov
c

	implicit none
	include 'netcdf.inc'

c---------------------------------------------------------------
c variables:

	character(200) filename
	character(80) long_name
	character(10) units
	character(8)  name
	character(1)  blank
	character(3) nm
        character(3) comp
        character(6) arg, gridtype, vertcoord
        character(14) datechar

	integer(2), allocatable :: byte(:)
        real(4), allocatable :: byte4(:)

        real(4), allocatable ::  fld(:,:,:)
        real(4), allocatable :: z(:), zi(:), p(:), pi(:), rho(:), rhoi(:), dz(:)
        real(8), allocatable :: lon(:), lat(:), loni(:), lati(:), wgt(:)
        real(4), allocatable :: x(:), y(:)
        real(4), allocatable :: f_min(:), f_max(:)
	real(4) dx,dy
        real(8) time,timeUTsec,timesec
	integer(4) nsubs,nsubsx,nsubsy,nx,ny,nz,nfields,nstep
	integer(4) i,in,j,k,k1,k2,n,i0,j0,nx_gl,ny_gl,count,ifields

	integer(4) vdimids(4), start(4), ndimids
	integer(4) ncid,err,zid,ziid,yid,yiid,xid,xiid,timeid,varid

        logical(4) savebin,dolatlon,dopres
        integer(4) gtype

c External functions:

	integer(4) iargc,strlen1
	external iargc,strlen1

c---------------------------------------------------------------

c
c Read the file-name from the comman line:
c
        i=COMMAND_ARGUMENT_COUNT()
        if(i.eq.0) then
          print*,'no input-file name is specified.'
          print*,'Format: 3D2nc_sepfields input.3D  (optional)latlon (optional)pres'
          stop
        end if
        call getarg(1,filename)
        print*,trim(filename)
        if(i.eq.2.or.i.eq.3) then
          call getarg(2,arg)
          if(arg.ne.'latlon'.and.arg.ne.'pres') then
            print*,'Optional argumentis are not latlon or pres.'
            print*,'Format: 3D2nc_sepfields input.3D (optional)latlon (optional)pres'
            print*,'Parameter latlon: force lat/lon cooedinates.'
            print*,'Parameter pres: force pressure cooedinates instead of height.'
            stop
          end if
          if(arg.eq.'latlon') then
           gridtype = arg
          else
           vertcoord = arg
          end if
        end if
        if(i.eq.3) then
          call getarg(3,arg)
          if(arg.ne.'latlon'.and.arg.ne.'pres') then
            print*,'Optional argumentis are not latlon or pres.'
            print*,'Format: 3D2nc_sepfields input.3D (optional)latlon (optional)pres'
            print*,'Parameter latlon: force lat/lon cooedinates.'
            print*,'Parameter pres: force pressure cooedinates instead of height.'
            stop
          end if
          if(arg.eq.'latlon') then
           gridtype = arg
          else
           vertcoord = arg
          end if
        end if
        print*,'gridtype=',gridtype
        print*,'vertcoord=',vertcoord
        if(vertcoord.eq.'pres') then
         dopres = .true.
        else
         dopres = .false.
        end if
        print*,'dopres=',dopres


c
c The output filename:

      do i=1,190
       if(filename(i:i+2).eq.'.3D') then
         EXIT
       else if(i.eq.190) then
         print*,'wrong filename extension!'
         stop
       endif
      end do
      in = i


c---------------------------------------------------------------
c Read files; merge data from different subdomains;
c save as a netcdf file.
c
	open(1,file=trim(filename),status='old',form='unformatted',action='read')
        read(1) nstep,timesec
	read(1) nx,ny,nz,nsubs,nsubsx,nsubsy,nfields
        print*,'nx,ny,nz,nsubs,nsubsx,nsubsy,nfields:',nx,ny,nz,nsubs,nsubsx,nsubsy,nfields
	nx_gl=nx*nsubsx
	ny_gl=ny*nsubsy
	print*,'nx_gl=',nx_gl
	print*,'ny_gl=',ny_gl
	print*,'nz=',nz
	read(1) dx, dy
	print*,'dx, dy:',dx,dy
	read(1) time,datechar,timeUTsec
	print*,'time= ',time
        print*,'DATE=',trim(datechar)
        print*,'timeUTsec=',timeUTsec
        read(1) dolatlon
        if(gridtype.eq.'latlon') dolatlon = .true.
        print*,'latlon grid? ',dolatlon
        read(1) comp
        print*,'component:',comp
        if(.not.allocated(z)) then
         allocate(z(nz),zi(nz),p(nz),pi(nz),x(nx_gl),y(ny_gl))
         allocate(lon(nx_gl),loni(nx_gl),lat(ny_gl),lati(ny_gl),wgt(ny_gl))
         allocate(rho(nz),rhoi(nz),dz(nz))
         allocate(f_min(nz),f_max(nz))
        end if
        read(1) z(1:nz),p(1:nz),lat(1:ny_gl),lon(1:nx_gl),lati(1:ny_gl),
     &           dz(1:nz),rho(1:nz),rhoi(1:nz),pi(1:nz),wgt(1:ny_gl)
        print*,'read...'
        do i=1,nx_gl
          x(i) = (i-1)*dx
          loni(i) = lon(i)-0.5*(lon(2)-lon(1))
        end do
        do j=1,ny_gl
          y(j) = (j-1)*dy
        end do
        zi(1)=0.
        do k=2,nz
         zi(k) = zi(k-1)+dz(k-1)
        end do
        print*,'z:',z(1:nz)
        print*,'zi:',zi(1:nz)
        print*,'p:',p(1:nz)
        print*,'pi:',pi(1:nz)
        print*,'rho:',rho(1:nz)
        print*,'rhoi:',rhoi(1:nz+1)
        if(dolatlon) then
         print*,'lat:',minval(lat),maxval(lat)
         print*,'lati:',minval(lati),maxval(lati)
         print*,'lon:',minval(lon),maxval(lon)
        else
         print*,'x:',minval(x),maxval(x)
         print*,'y:',minval(y),maxval(y)
        end if

	allocate (byte(nx*ny*nz))
	allocate (byte4(nx*ny*nz))
	allocate (fld(nx_gl,ny_gl,nz))

      ifields=0
 
      do while(ifields.lt.nfields)

	read(1) name,blank,long_name,blank,units
	print*, trim(name),blank,trim(long_name),blank,trim(units)
c
c Initialize netcdf stuff, define variables,etc.
c
	err = NF_CREATE(filename(:in-1)//"_"//trim(name)//".3D_"//comp//".nc", 
     &                  ior(nf_clobber,nf_64bit_offset), ncid)
	err = NF_REDEF(ncid)
        print*,filename(:in-1)//"_"//trim(name)//".3D_"//comp//".nc"

        if(dolatlon) then
         err = NF_DEF_DIM(ncid, 'lon', nx_gl, xid)
         err = NF_DEF_DIM(ncid, 'lonu', nx_gl, xiid)
         if(ny_gl.ne.1)err = NF_DEF_DIM(ncid, 'lat', ny_gl, yid)
         if(ny_gl.ne.1)err = NF_DEF_DIM(ncid, 'latv', ny_gl, yiid)
        else
         err = NF_DEF_DIM(ncid, 'x', nx_gl, xid)
         xiid = xid
         if(ny_gl.ne.1)then
          err = NF_DEF_DIM(ncid, 'y', ny_gl, yid)
          yiid = yid
         end if
        end if
        if(dopres) then
         err = NF_DEF_DIM(ncid, 'lev', nz, zid)
         err = NF_DEF_DIM(ncid, 'levi', nz, ziid)
        else
         err = NF_DEF_DIM(ncid, 'z', nz, zid)
         err = NF_DEF_DIM(ncid, 'zi', nz, ziid)
        end if
        err = NF_DEF_DIM(ncid, 'time', NF_UNLIMITED, timeid)


        if(dolatlon) then
          err = NF_DEF_VAR(ncid, 'lon', NF_DOUBLE, 1, xid, varid)
          err = NF_PUT_ATT_TEXT(ncid,varid,'units',12,'degrees east')
          err = NF_DEF_VAR(ncid, 'lonu', NF_DOUBLE, 1, xiid, varid)
          err = NF_PUT_ATT_TEXT(ncid,varid,'units',12,'degrees east')
          if(ny_gl.ne.1) then
           err = NF_DEF_VAR(ncid, 'lat', NF_DOUBLE, 1, yid, varid)
           err = NF_PUT_ATT_TEXT(ncid,varid,'units',13,'degrees north')
           err = NF_DEF_VAR(ncid, 'latv', NF_DOUBLE, 1, yiid, varid)
           err = NF_PUT_ATT_TEXT(ncid,varid,'units',13,'degrees north')
           err = NF_DEF_VAR(ncid, 'wgt', NF_DOUBLE, 1, yid, varid)
           err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',17,'averaging wieghts')
          endif
        else
          err = NF_DEF_VAR(ncid, 'x', NF_REAL, 1, xid, varid)
          err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
          if(ny_gl.ne.1) then
           err = NF_DEF_VAR(ncid, 'y', NF_REAL, 1, yid, varid)
           err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
          endif
        end if
        if(dopres) then
         err = NF_DEF_VAR(ncid, 'lev', NF_REAL, 1, zid, varid)
         err = NF_PUT_ATT_TEXT(ncid,varid,'units',3,'hPa')
         err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',8,'pressure')
         err = NF_DEF_VAR(ncid, 'levi', NF_REAL, 1, ziid, varid)
         err = NF_PUT_ATT_TEXT(ncid,varid,'units',3,'hPa')
         err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',18,'interface pressure')
        else
         err = NF_DEF_VAR(ncid, 'p', NF_REAL, 1, zid,varid)
         err = NF_PUT_ATT_TEXT(ncid,varid,'units',2,'mb')
         err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',8,'pressure')
         err = NF_DEF_VAR(ncid, 'pi', NF_REAL, 1, ziid,varid)
         err = NF_PUT_ATT_TEXT(ncid,varid,'units',2,'mb')
         err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',18,'interface pressure')
        end if
        err = NF_DEF_VAR(ncid, 'z', NF_REAL, 1, zid, varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',6,'height')
        err = NF_DEF_VAR(ncid, 'zi', NF_REAL, 1, ziid, varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',16,'interface height')
        err = NF_DEF_VAR(ncid, 'time', NF_DOUBLE, 1, timeid, varid)
        if(timeUTsec.gt.0._8) then
          err = NF_PUT_ATT_TEXT(ncid,varid,'units',35,'seconds since 1900-01-01 00:00:00.0')
          err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',4,'time')
          err = NF_PUT_ATT_TEXT(ncid,varid,'calendar',9,'gregorian')
          err = NF_DEF_VAR(ncid,'day',NF_DOUBLE, 1, timeid, varid)
          err = NF_PUT_ATT_TEXT(ncid,varid,'units',3,'day')
          err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',3,'day')
        else
          err = NF_PUT_ATT_TEXT(ncid,varid,'units',3,'day')
          err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',4,'time')
        end if
        err = NF_DEF_VAR(ncid,'timesec',NF_DOUBLE, 1, timeid, varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'s')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',15,'run time in sec')

        err = NF_DEF_VAR(ncid, 'dz', NF_REAL, 1, zid,varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',1,'m')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',15,'layer thinkness')
        err = NF_DEF_VAR(ncid, 'rho', NF_REAL, 1, zid,varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',5,'kg/m3')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',7,'density')
        err = NF_DEF_VAR(ncid, 'rhoi', NF_REAL, 1, ziid,varid)
        err = NF_PUT_ATT_TEXT(ncid,varid,'units',5,'kg/m3')
        err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',17,'interface density')

	err = NF_ENDDEF(ncid)

        if(dolatlon) then
	  err = NF_INQ_VARID(ncid,'lon',varid)
	  err = NF_PUT_VAR_DOUBLE(ncid, varid, lon)
          err = NF_INQ_VARID(ncid,'lonu',varid)
          err = NF_PUT_VAR_DOUBLE(ncid, varid, loni)
	  if(ny_gl.ne.1) then
	  err = NF_INQ_VARID(ncid,'lat',varid)
	  err = NF_PUT_VAR_DOUBLE(ncid, varid, lat)
	  err = NF_INQ_VARID(ncid,'latv',varid)
	  err = NF_PUT_VAR_DOUBLE(ncid, varid, lati)
          err = NF_INQ_VARID(ncid,'wgt',varid)
          err = NF_PUT_VAR_DOUBLE(ncid, varid, wgt)
	  endif
        else
	  err = NF_INQ_VARID(ncid,'x',varid)
	  err = NF_PUT_VAR_REAL(ncid, varid, x)
	  if(ny_gl.ne.1) then
	  err = NF_INQ_VARID(ncid,'y',varid)
	  err = NF_PUT_VAR_REAL(ncid, varid, y)
	  endif
        end if

        if(dopres) then
         err = NF_INQ_VARID(ncid,'lev',varid)
         err = NF_PUT_VAR_REAL(ncid, varid, p)
         err = NF_INQ_VARID(ncid,'levi',varid)
         err = NF_PUT_VAR_REAL(ncid, varid, pi)
        else
         err = NF_INQ_VARID(ncid,'z',varid)
         err = NF_PUT_VAR_REAL(ncid, varid, z)
         err = NF_INQ_VARID(ncid,'zi',varid)
         err = NF_PUT_VAR_REAL(ncid, varid, zi)
        end if

	err = NF_INQ_VARID(ncid,'time',varid)
        if(timeUTsec.gt.0._8) then
            err = NF_PUT_VAR1_DOUBLE(ncid,varid,1,timeUTsec)
            err = NF_INQ_VARID(ncid,'day',varid)
            err = NF_PUT_VAR1_DOUBLE(ncid,varid,1,time)
        else
            err = NF_PUT_VAR1_DOUBLE(ncid,varid,1,time)
        end if
        err = NF_INQ_VARID(ncid,'timesec',varid)
        err = NF_PUT_VAR1_DOUBLE(ncid,varid,1,timesec)

        err = NF_INQ_VARID(ncid,'p',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, p)
        err = NF_INQ_VARID(ncid,'pi',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, pi)
        err = NF_INQ_VARID(ncid,'dz',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, dz)
        err = NF_INQ_VARID(ncid,'rho',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, rho)
        err = NF_INQ_VARID(ncid,'rhoi',varid)
        err = NF_PUT_VAR_REAL(ncid, varid, rhoi)


        read(1) savebin,gtype
        print*,'savebin=',savebin,'gtype=',gtype
        if(.not.savebin) read(1) f_max(1:nz),f_min(1:nz)

        if(ny_gl.ne.1) then
         ndimids=4
!         if(gtype.eq.4) then
!            vdimids(1) = xiid
!         else
            vdimids(1) = xid
!         end if
!         if(gtype.eq.3) then
!            vdimids(2) = yiid
!         else
            vdimids(2) = yid
!         end if
!         if(gtype.eq.2) then
!            vdimids(3) = ziid
!         else
            vdimids(3) = zid
!         end if
         vdimids(4) = timeid
        else
         ndimids=3
!         if(gtype.eq.4) then
!            vdimids(1) = xiid
!         else
            vdimids(1) = xid
!         end if
!         if(gtype.eq.2) then
!            vdimids(2) = ziid
!         else
            vdimids(2) = zid
!         end if
         vdimids(3) = timeid
        endif

	
	do n=0,nsubs-1
	  
	    j0 = n/nsubsx 
	    i0 = n - j0*nsubsx	
	    i0 = i0 * (nx_gl/nsubsx) 
	    j0 = j0 * (ny_gl/nsubsy)  

            if(savebin) then
     	      read(1) byte4(:)
	      count=0
	      do k=1,nz
	       do j=1+j0,ny+j0
	        do i=1+i0,nx+i0
                  count=count+1
                  fld(i,j,k)=byte4(count)
	        end do
	       end do
	      end do
            else
     	       read(1) byte(:)
	       count=0
	       do k=1,nz
	        do j=1+j0,ny+j0
	         do i=1+i0,nx+i0
		   count=count+1
		   fld(i,j,k)=f_min(k)+(byte(count)+32000.)*(f_max(k)-f_min(k))/64000.
	         end do
	        end do
	       end do
            end if

	end do ! n

	print*,long_name,minval(fld),maxval(fld)

	ifields=ifields+1

	err = NF_REDEF(ncid)
        err = NF_DEF_VAR(ncid,name, NF_FLOAT, ndimids, vdimids, varid)
	err = NF_PUT_ATT_TEXT(ncid,varid,'long_name',
     &		strlen1(trim(long_name)),trim(long_name))
	err = NF_PUT_ATT_TEXT(ncid,varid,'units',
     &		strlen1(trim(units)),trim(units))
	err = NF_ENDDEF(ncid)
	err = NF_PUT_VAR_REAL(ncid, varid, fld)


	err = NF_CLOSE(ncid)

      end do ! while

      end
	




	integer function strlen1(str)
	character*(*) str
	strlen1=len(str)
	do i=1,len(str)
	  if(str(i:i).ne.' ') then
	    strlen1=strlen1-i+1
	    return
	  endif 
	end do
        return
	end
